<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>

<style>
   
    *{
        font-family:Verdana, Geneva, Tahoma, sans-serif;
        margin: 0;
        padding: 0;

    }
    p{
        margin-left: 15%;
        margin-top: 10px;
    }

    legend{
        text-align: center;
    }

    #remove{
        margin-top: 8%;

    }

   fieldset{
        background-color: #F8F7F9;
        padding: 0 5% 5% 5%;
        display: flex;
        flex-direction: column;
        
        margin: 0 15%;
    }
    label{
        margin-bottom: 2%;
    }
    input{
        padding-bottom: 5px;
        padding-top: 5px;
        
    }
    #add{
        margin-left: 15%;
        margin-top: 12px;
        background-color: white;
        padding: 4px;
        
    }

    #change2{
        margin-top: 8px;
    }
    #change, #index, #textindex{
        visibility: hidden;
        margin-top: 8px;
    }

</style>
<body>


    <fieldset>
        <legend>Cotações</legend>
        <label for="contações" required>Título</label>
        <input id ="text" type="text"></input>
        
        <label for="contações" id ="index">posição</label>
        <input id ="textindex" type="number"></input>
        <button onclick= "changeItem()" id="change">confirmar</button>
        
        <button onclick= "removeItem()" id="remove">Remover</button>
        <button onclick= "appearChangeOption()" id="change2" >mudar cotação</button>
    </fieldset>

    <button onclick= "addItem()" id="add">Adicionar cotação</button>
<div id="items">
  
</div>


    <script>
    //array pra armazenar as cotações
    let array = [];
    //variável auxiliar
    let aux
    var list =  document.getElementById("items")
   
   //adicionando item ao array
    function addItem(){
        //a função só irá rodar se não tiver valor no input das cotações
        if(document.getElementById("text").value != null){
       //adicionando o valor presente no input ao array
        array.push(document.getElementById("text").value)
       //criando um elemento paragrafo e um textnode com o valor do imput que deseja adicionar
        var item = document.createElement("p")
        var cotação = document.createTextNode((array[array.length - 1]))
       
       //adicionando o valor do input ao paragrafo eo paragrafo no div de id = "items"
        item.appendChild(cotação) 
        list.appendChild(item)
    }
}
    //removendo o item do array
    function removeItem(){
        //loop pelo array para checar se há algum item correspondente ao que se deseja apagar
        for(let i = 0; i < array.length;i++){
            if(document.getElementById("text").value == array[i]){
               //troca de valores entre o primeiro item do array e o item da posição i
               aux = array[i]
                array[i] = array[0]
                array[0] = aux
                //elliminando o primeiro item do array e removendo o paragrafo do div = "items"
                array.pop
                list.removeChild(document.getElementsByTagName("p")[i])
                break;
            }
        }
    }
    
    function appearChangeOption(){
        //tornando visíveis os elementos do fieldset para poder realizar a troca de valor de um elemento
        document.getElementById("textindex").style.visibility = "visible"
        document.getElementById("index").style.visibility = "visible"
        document.getElementById("change").style.visibility = "visible"
    }

    function changeItem(){
        //condicional para se o valor dentro do input de index for menor que o tamanho do vetor
        if(document.getElementById("textindex").value < array.length){
           
           //removendo item da posição colocada no index
            list.removeChild(document.getElementsByTagName("p")[document.getElementById("textindex").value])
           
           //criando um elemento paragrafo e um textnode com o valor do imput que deseja trocar
            var item = document.createElement("p")
            var changeditem = document.createTextNode(document.getElementById("text").value)
           
           //adicionando item ao div com id = "items"
            item.appendChild(changeditem) 
            
            //adicionando o novo parágrafo ao array na posição do paragrafo removido
            list.replaceChild(item, list.childNodes[document.getElementById("textindex").value])
            
            //tirando a visibilidade dos elementos para realizar a troca de valores
            document.getElementById("textindex").style.visibility = "hidden"
            document.getElementById("index").style.visibility = "hidden"
            document.getElementById("change").style.visibility = "hidden"
        }
    }

    </script>



</body>

</html>